﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Maps;

namespace XamMap_translate_from_map
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            xamMap1.ViewportMargin = new Thickness(50);
        }

        private void xamMap1_ElementClick_1(object sender, Infragistics.Controls.Maps.MapElementClickEventArgs e)
        {
            Matrix M = ViewportMatrix(sender as XamMap);

            MatrixTransform transform = new MatrixTransform(M);

            //Center
            Point MainWindowPoint = transform.Transform(e.Element.ActualSymbolOrigin);
            
            ////TopLeft
            //Point MainWindowPoint = transform.Transform(e.Element.WorldRect.TopLeft);

            // Negate offset from inner map settings like ViewportMargin
            Point MapOffset = xamMap1.Viewport.TranslatePoint(new Point(0, 0), xamMap1);

            (this.Content as Grid).Children.Add(new Ellipse()
            {
                Height = 5,
                Width = 5,
                Fill = Brushes.White,
                Margin = new Thickness(MainWindowPoint.X - 2.5 + MapOffset.X, MainWindowPoint.Y - 2.5 + MapOffset.Y, 0, 0),
                HorizontalAlignment = System.Windows.HorizontalAlignment.Left,
                VerticalAlignment = System.Windows.VerticalAlignment.Top
            });

        }


        Matrix ViewportMatrix(XamMap map)
        {
            Rect viewportRect = map.ViewportRect;
            Rect worldRect = map.ActualWorldRect;
            Point windowCenter = map.WindowCenter;
            double windowScale = map.WindowScale;
            Point viewportCenter = new Point(map.ViewportRect.Left + map.ViewportRect.Width / 2,
                             map.ViewportRect.Top + map.ViewportRect.Height / 2);

            double scale = Math.Min(viewportRect.Width / worldRect.Width, viewportRect.Height / worldRect.Height) * windowScale;

            Matrix matrix = new Matrix();

            matrix.M11 = scale;
            matrix.M12 = 0;
            matrix.M21 = 0;
            matrix.M22 = scale;
            matrix.OffsetX = -windowCenter.X * scale + viewportCenter.X;
            matrix.OffsetY = -windowCenter.Y * scale + viewportCenter.Y;

            return matrix;
        }
    }
}
